[erdb4:local/src/archiveopteryx] root# git diff -R -u instrumentation hung_patch_from_arnt
diff --git b/hung_patch_from_arnt/aox/.git/config a/instrumentation/aox/.git/config
index d6aafc3..8606904 100644
--- b/hung_patch_from_arnt/aox/.git/config
+++ a/instrumentation/aox/.git/config
@@ -4,7 +4,7 @@
        bare = false
        logallrefupdates = true
 [remote "origin"]
-       url = git@github.com:aox/aox
+       url = https://github.com/mc3/aox
        fetch = +refs/heads/*:refs/remotes/origin/*
 [branch "master"]
        remote = origin
diff --git b/hung_patch_from_arnt/aox/.git/logs/HEAD a/instrumentation/aox/.git/logs/HEAD
index db9a9f9..b0701af 100644
--- b/hung_patch_from_arnt/aox/.git/logs/HEAD
+++ a/instrumentation/aox/.git/logs/HEAD
@@ -1 +1 @@
-0000000000000000000000000000000000000000 429c9404f9bb7ae1045093ceb9a3450d07fcefa7 Axel Rau <axel.rau@chaos1.de> 1499975747 +0000       clone: from git@github.com:aox/aox
+0000000000000000000000000000000000000000 b48331f7f63e52a5f2c0240595ca5724f82e0944 Axel Rau <axel.rau@chaos1.de> 1486486765 +0000       clone: from https://github.com/mc3/aox
diff --git b/hung_patch_from_arnt/aox/.git/logs/refs/heads/master a/instrumentation/aox/.git/logs/refs/heads/master
index db9a9f9..b0701af 100644
--- b/hung_patch_from_arnt/aox/.git/logs/refs/heads/master
+++ a/instrumentation/aox/.git/logs/refs/heads/master
@@ -1 +1 @@
-0000000000000000000000000000000000000000 429c9404f9bb7ae1045093ceb9a3450d07fcefa7 Axel Rau <axel.rau@chaos1.de> 1499975747 +0000       clone: from git@github.com:aox/aox
+0000000000000000000000000000000000000000 b48331f7f63e52a5f2c0240595ca5724f82e0944 Axel Rau <axel.rau@chaos1.de> 1486486765 +0000       clone: from https://github.com/mc3/aox
diff --git b/hung_patch_from_arnt/aox/.git/logs/refs/remotes/origin/HEAD a/instrumentation/aox/.git/logs/refs/remotes/origin/HEAD
index db9a9f9..b0701af 100644
--- b/hung_patch_from_arnt/aox/.git/logs/refs/remotes/origin/HEAD
+++ a/instrumentation/aox/.git/logs/refs/remotes/origin/HEAD
@@ -1 +1 @@
-0000000000000000000000000000000000000000 429c9404f9bb7ae1045093ceb9a3450d07fcefa7 Axel Rau <axel.rau@chaos1.de> 1499975747 +0000       clone: from git@github.com:aox/aox
+0000000000000000000000000000000000000000 b48331f7f63e52a5f2c0240595ca5724f82e0944 Axel Rau <axel.rau@chaos1.de> 1486486765 +0000       clone: from https://github.com/mc3/aox
diff --git b/hung_patch_from_arnt/aox/.git/packed-refs a/instrumentation/aox/.git/packed-refs
index bea595f..38f3516 100644
--- b/hung_patch_from_arnt/aox/.git/packed-refs
+++ a/instrumentation/aox/.git/packed-refs
@@ -1,5 +1,6 @@
 # pack-refs with: peeled fully-peeled 
-429c9404f9bb7ae1045093ceb9a3450d07fcefa7 refs/remotes/origin/master
+b48331f7f63e52a5f2c0240595ca5724f82e0944 refs/remotes/origin/master
+848a52933ede3588324ffc9fa87291887734a68b refs/remotes/origin/pgp_sig_ml_fix
 ef1e2b935840ec35f338af64ae1d75053677bf06 refs/tags/v2.08
 ^7af7cbfb4a39a60edb480af8eb563544fa166096
 f010edf5c86f26ccd5b70afa773390a95541efd8 refs/tags/v2.09
diff --git b/hung_patch_from_arnt/aox/.git/refs/heads/master a/instrumentation/aox/.git/refs/heads/master
index ea0abdf..a42fbbb 100644
--- b/hung_patch_from_arnt/aox/.git/refs/heads/master
+++ a/instrumentation/aox/.git/refs/heads/master
@@ -1 +1 @@
-429c9404f9bb7ae1045093ceb9a3450d07fcefa7
+b48331f7f63e52a5f2c0240595ca5724f82e0944
diff --git b/hung_patch_from_arnt/aox/Jamrules a/instrumentation/aox/Jamrules
index 91fabe8..aa06125 100644
--- b/hung_patch_from_arnt/aox/Jamrules
+++ a/instrumentation/aox/Jamrules
@@ -13,6 +13,7 @@ if $(OPTIM) = "-O" {
     OPTIM = "-O3" ;
 }
 OPTIM ?= ;
+#OPTIM = "-O3";
 RANLIB = ;
 
 USE_X86_ASM = ;
diff --git b/hung_patch_from_arnt/aox/Jamsettings a/instrumentation/aox/Jamsettings
index 6ad07ee..0d67c6d 100644
--- b/hung_patch_from_arnt/aox/Jamsettings
+++ a/instrumentation/aox/Jamsettings
@@ -71,7 +71,8 @@ AOXGROUP ?= aox ;
 
 # How to compile
 
-C++FLAGS = -g -funsigned-char ;
+C++FLAGS = -g -funsigned-char -O3 ;
+#C++FLAGS = -g -funsigned-char ;
 LINKFLAGS = -g ;
 
 # Mode for installed binaries
diff --git b/hung_patch_from_arnt/aox/abnf/abnfparser.cpp a/instrumentation/aox/abnf/abnfparser.cpp
index 0900b26..40b1a15 100644
--- b/hung_patch_from_arnt/aox/abnf/abnfparser.cpp
+++ a/instrumentation/aox/abnf/abnfparser.cpp
@@ -168,8 +168,7 @@ bool AbnfParser::present( const EString & s )
 void AbnfParser::require( const EString & s )
 {
     if ( !present( s ) )
-        setError( "Expected: " + s.quoted() + " at " + fn( d->at ) +
-                  ", got: " + following() );
+        setError( "Expected: " + s.quoted() + ", got: " + following() );
 }
 
 
diff --git b/hung_patch_from_arnt/aox/aox/db.cpp a/instrumentation/aox/aox/db.cpp
index af5edbb..24a7dca 100644
--- b/hung_patch_from_arnt/aox/aox/db.cpp
+++ a/instrumentation/aox/aox/db.cpp
@@ -173,16 +173,13 @@ void Vacuum::execute()
                 qstate = 1;
                 log( "vacuum: delete from deliveries", Log::Significant );
                 do {
-                    // Literals have changed meaning in c++11, we need spaces
-                    // or they have potentially changed effect in future
-                    // http://www.preney.ca/paul/archives/636
                     q = new Query( "delete from deliveries "
                                    "where injected_at<current_timestamp-'" +
                                    fn( days ) + " days'::interval "
                                    "and id in "
                                    "(select delivery from delivery_recipients "
                                    " where action not in ($1,$2) "
-                                   " limit " MSGBLOCKCOUNT ") "
+                                   " limit "MSGBLOCKCOUNT") "
                                    "and id not in "
                                    "(select delivery from delivery_recipients "
                                    " where action in ($1,$2))", this );
@@ -212,7 +209,7 @@ void Vacuum::execute()
                                    " left join deliveries d on (m.id=d.message)"
                                    " where mm.message is null and dm.message is null"
                                    " and d.message is null "
-                                   " limit " MSGBLOCKCOUNT ")", this );
+                                   " limit "MSGBLOCKCOUNT")", this );
                     q->execute();
             case 3:
                     if (!q->done())
@@ -224,7 +221,7 @@ void Vacuum::execute()
                     q = new Query( "delete from bodyparts where id in (select id "
                                    "from bodyparts b left join part_numbers p on "
                                    "(b.id=p.bodypart) where bodypart is null "
-                                   " limit " MSGBLOCKCOUNT ")", this );
+                                   " limit "MSGBLOCKCOUNT")", this );
                     q->execute();
             case 4:
                     if (!q->done())
diff --git b/instrumentation/aox/build/clang/COPYING a/instrumentation/aox/build/clang/COPYING
new file mode 100644
index 0000000..fc34d88
--- /dev/null
+++ a/instrumentation/aox/build/clang/COPYING
@@ -0,0 +1,4 @@
+Archiveopteryx 3.2.0 is licensed to you by Oryx Mail Systems GmbH
+under the PostgreSQL License, a copy of which is enclosed in the file
+bsd.txt. We adapted the text from that used by PostgreSQL,
+http://www.postgresql.org/about/licence
diff --git b/instrumentation/aox/build/clang/README a/instrumentation/aox/build/clang/README
new file mode 100644
index 0000000..4dc59be
--- /dev/null
+++ a/instrumentation/aox/build/clang/README
@@ -0,0 +1,131 @@
+Archiveopteryx
+http://archiveopteryx.org
+
+
+See http://archiveopteryx.org/overview for an introduction
+and http://archiveopteryx.org/3.2.0 for information about
+version 3.2.0.
+
+
+Requirements
+------------
+
+You need g++ (and associated packages) to build this software.
+
+You need to have PostgreSQL installed to use Archiveopteryx. We
+recommend the latest 9.x version (but anything newer than 9.1
+should work; see http://archiveopteryx.org/postgresql/).
+
+
+Installation
+------------
+
+For detailed installation instructions, see:
+http://archiveopteryx.org/installation
+
+Here's a brief overview of the steps to follow while installing
+Archiveopteryx for the first time (see below if you're upgrading):
+
+1. Type "make" to compile the software.
+
+   We test the build on Linux and FreeBSD. You may encounter some errors
+   if you compile elsewhere. We make few demands of the platform, so any
+   errors are likely to be minor, and if you tell us about them, we'd be
+   happy to help you resolve them.
+
+2. Type "make install" as root to install the software into /usr/local/archiveopteryx
+   (then switch to that directory to continue).
+
+   The archiveopteryx(7) manual page introduces the software.
+
+   (You may want to add /usr/local/archiveopteryx/man to your MANPATH.)
+
+3. Run "lib/installer" to create a Unix user and group, a PostgreSQL
+   user, the necessary database tables, and to generate an initial
+   configuration file.
+
+   See installer(8) for details, or run "lib/installer -n" to see what
+   commands the installer would run, without running them.
+
+   The generated configuration file should work fine, but you may need
+   to edit it, for example, to enable POP3, or make the servers listen
+   on some interface other than localhost. See archiveopteryx.conf(5)
+   for more details.
+
+4. Start the servers: "bin/aox start".
+
+   aox is the command-line administration tool for Archiveopteryx.
+   See aox(8) or run "bin/aox help" for usage instructions.
+
+   The servers write log output to syslog/mail.
+
+   (To start the servers automatically at boot, use lib/archiveopteryx
+   as an init script.)
+
+5. Create some users, e.g. with:
+
+       bin/aox add user nirmala pwd nirmala@example.com
+
+   Archiveopteryx will create a user named nirmala (with password "pwd")
+   and accept mail sent to the given address, and store it in a mailbox
+   named /users/nirmala/INBOX, which can be accessed via IMAP or POP.
+
+6. Configure your MTA to deliver incoming mail into Archiveopteryx via
+   LMTP (or via bin/deliver, if your MTA doesn't speak LMTP). See, e.g.
+   http://archiveopteryx.org/postfix and .../exim for details.
+
+7. Add an entry to root's crontab to run "aox vacuum" daily. Remember to
+   enable PostgreSQL's "autovacuum" feature too (strongly recommended),
+   or at least to run "vacuumdb -qaz" from the postgres user's crontab.
+   You'll also need to adjust the memory settings in postgresql.conf
+   (shared_buffers, effective_cache_size) for better performance.
+
+
+Upgrading Archiveopteryx
+------------------------
+
+1. "make" and "make install" as above.
+
+2. Upgrade the schema, if necessary: "aox stop; aox upgrade schema"
+
+   We sometimes change the database schema between releases, so you may
+   need to stop the server and upgrade the schema. You can check if the
+   schema is up to date with "aox show schema". The new server will not
+   start until the schema is at the version it expects.
+
+   It is safe to run "aox upgrade schema" when the server is stopped. If
+   it doesn't need to do anything, it will just exit.
+
+   We try to keep schema upgrades fast, to minimise downtime.
+
+3. Restart the servers: "aox restart"
+
+4. Update the database, if necessary: "aox update database"
+
+   Very rarely, we may need to make extensive changes to the database.
+   In this case, you will need to run "aox update database" after you
+   install and start the new server. The server will operate normally
+   as the update proceeds. The release notes for a particular version
+   will always mention it if you need to update the database.
+
+   It is always safe to run "aox update database", whether the server is
+   stopped or running. If it doesn't need to do anything, it will exit.
+   If the process is terminated, it is safe to restart it; it will pick
+   up where it left off.
+
+
+Mailing Lists
+-------------
+
+There are mailing lists for Archiveopteryx users and announcements. To
+subscribe to the users list (which also gets announcements), send mail:
+
+    echo|mail -s subscribe users-request@aox.org
+
+To subscribe instead to the low-volume announcements list:
+
+    echo|mail -s subscribe announce-request@aox.org
+
+
+If you encounter any problems or have any suggestions, please write to
+info@aox.org. Your comments help us improve Archiveopteryx.
diff --git b/instrumentation/aox/build/clang/downgrades a/instrumentation/aox/build/clang/downgrades
new file mode 100644
index 0000000..b8c0fed
--- /dev/null
+++ a/instrumentation/aox/build/clang/downgrades
@@ -0,0 +1,155 @@
+create or replace function downgrade_to_84()
+returns int as $$
+begin
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_83()
+returns int as $$
+begin
+    drop table retention_policies;
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_82()
+returns int as $$
+begin
+    insert into flags (mailbox, uid, flag)
+        select mailbox, uid, (select id from flag_names where name=E'\\\\Seen')
+        from mailbox_messages where seen;
+    insert into flags (mailbox, uid, flag)
+        select mailbox, uid, (select id from flag_names where name=E'\\\\Deleted')
+        from mailbox_messages where deleted;
+    alter table mailbox_messages drop seen, drop deleted;
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_81()
+returns int as $$
+begin
+    drop trigger mailbox_update_trigger on mailboxes;
+    drop function check_mailbox_update();
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_80()
+returns int as $$
+begin
+    drop trigger mailbox_owner_trigger on mailboxes;
+    drop function set_mailbox_owner();
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_85()
+returns int as $$
+begin
+    drop trigger retention_policies_trigger on retention_policies;
+    drop function notify_retention_policies();
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_86()
+returns int as $$
+begin
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_87()
+returns int as $$
+begin
+    alter table users alter alias set not null;
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_88()
+returns int as $$
+begin
+    alter table connections add userid integer;
+    update connections set userid=users.id from users where users.login=connections.username;
+    alter table connections drop username;
+    alter table connections add foreign key(userid) references users(id);
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_89()
+returns int as $$
+begin
+    alter table deliveries drop deliver_after;
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_90()
+returns int as $$
+begin
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_91()
+returns int as $$
+begin
+    alter table connections drop userid;
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_92()
+returns int as $$
+begin
+    alter table users drop quota;
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_93()
+returns int as $$
+begin
+    alter table group_members rename groupid to groupname;
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_94()
+returns int as $$
+begin
+    alter table messages drop thread_root;
+    drop table thread_roots;
+    drop function merge_threads(integer,integer);
+    create table threads (
+        id serial primary key,
+        mailbox integer not null references mailboxes(id),
+        subject text,
+        unique (mailbox, subject)
+    );
+    create table thread_members (
+        thread integer not null references threads(id),
+        mailbox integer not null,
+        uid integer not null,
+        primary key (thread, mailbox, uid),
+        foreign key (mailbox, uid) references mailbox_messages(mailbox, uid)
+            on delete cascade
+    );
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_95()
+returns int as $$
+begin
+    drop index addresses_ldn_key;
+    alter table addresses alter localpart type text;
+    alter table addresses alter domain type text;
+    create unique index addresses_nld_key on addresses(name,localpart,lower(domain));
+    create index ald on addresses(lower(localpart), lower(domain));
+    return 0;
+end;$$ language 'plpgsql';
+
+create or replace function downgrade_to_96()
+returns int as $$
+begin
+    create table views (
+        id          serial primary key,
+        source      integer not null references mailboxes(id)
+                    on delete cascade,
+        view        integer not null references mailboxes(id)
+                    on delete cascade unique,
+        nextmodseq  bigint not null,
+        selector    text
+    );
+    return 0;
+end;$$ language 'plpgsql';
diff --git b/instrumentation/aox/build/clang/field-names a/instrumentation/aox/build/clang/field-names
new file mode 100644
index 0000000..dd5aaf3
--- /dev/null
+++ a/instrumentation/aox/build/clang/field-names
@@ -0,0 +1,32 @@
+insert into field_names (name) values ('From');
+insert into field_names (name) values ('Resent-From');
+insert into field_names (name) values ('Sender');
+insert into field_names (name) values ('Resent-Sender');
+insert into field_names (name) values ('Return-Path');
+insert into field_names (name) values ('Reply-To');
+insert into field_names (name) values ('To');
+insert into field_names (name) values ('Cc');
+insert into field_names (name) values ('Bcc');
+insert into field_names (name) values ('Resent-To');
+insert into field_names (name) values ('Resent-Cc');
+insert into field_names (name) values ('Resent-Bcc');
+insert into field_names (name) values ('Message-Id');
+insert into field_names (name) values ('Resent-Message-Id');
+insert into field_names (name) values ('In-Reply-To');
+insert into field_names (name) values ('References');
+insert into field_names (name) values ('Date');
+insert into field_names (name) values ('Orig-Date');
+insert into field_names (name) values ('Resent-Date');
+insert into field_names (name) values ('Subject');
+insert into field_names (name) values ('Comments');
+insert into field_names (name) values ('Keywords');
+insert into field_names (name) values ('Content-Type');
+insert into field_names (name) values ('Content-Transfer-Encoding');
+insert into field_names (name) values ('Content-Disposition');
+insert into field_names (name) values ('Content-Description');
+insert into field_names (name) values ('Content-Id');
+insert into field_names (name) values ('Mime-Version');
+insert into field_names (name) values ('Received');
+insert into field_names (name) values ('Content-Language');
+insert into field_names (name) values ('Content-Location');
+insert into field_names (name) values ('Content-Md5');
diff --git b/instrumentation/aox/build/clang/flag-names a/instrumentation/aox/build/clang/flag-names
new file mode 100644
index 0000000..7418b77
--- /dev/null
+++ a/instrumentation/aox/build/clang/flag-names
@@ -0,0 +1,5 @@
+insert into flag_names (name) values (E'\\\\Deleted');
+insert into flag_names (name) values (E'\\\\Answered');
+insert into flag_names (name) values (E'\\\\Flagged');
+insert into flag_names (name) values (E'\\\\Draft');
+insert into flag_names (name) values (E'\\\\Seen');
diff --git b/instrumentation/aox/build/clang/fts.pg a/instrumentation/aox/build/clang/fts.pg
new file mode 100644
index 0000000..209ecd4
--- /dev/null
+++ a/instrumentation/aox/build/clang/fts.pg
@@ -0,0 +1,60 @@
+-- There are a couple of things you need to do manually:
+--
+--     1. psql archiveopteryx -f contrib/tsearch2.sql
+--     2. createlang plpgsql archiveopteryx
+--     3. Find out what your current locale is (e.g. "show lc_ctype")
+--        and execute the following statement (assuming a locale of
+--        'en_US.UTF-8'):
+--
+--        update pg_ts_cfg set locale='en_US.UTF-8' where \\
+--        ts_name='default';
+--
+-- The remainder of the script may then be executed with psql -f fts.pg.
+
+
+-- Allow Archiveopteryx to use tsearch2.
+
+grant select on pg_ts_dict to aox;
+grant select on pg_ts_parser to aox;
+grant select on pg_ts_cfg to aox;
+grant select on pg_ts_cfgmap to aox;
+
+
+-- Create a new GiST index on bodyparts.text, and a trigger to update
+-- the index every time a new entry is inserted.
+
+alter table bodyparts add ftidx tsvector;
+update bodyparts set ftidx=to_tsvector('default',text) where length(text) < 1048576;
+create index bodyparts_ftidx on bodyparts using gist(ftidx);
+vacuum full analyze bodyparts;
+
+create trigger bodyparts_ftupdate before insert on bodyparts
+for each row execute procedure tsearch2(ftidx, text);
+
+
+-- XXX: The following code is disabled, because we use copy ... binary
+-- to populate header_fields, and there's no binary input function for
+-- the tsvector type. Do we have to use INSERT if we're running with
+-- db = postgres+tsearch2? If so, perhaps we can use COPY on structured
+-- and INSERT on unstructured fields?
+--
+-- Create a new GiST index on header_fields.value for Subject fields,
+-- and a trigger to update the index every time a new Subject field
+-- is inserted.
+--
+-- alter table header_fields add subjectidx tsvector;
+-- update header_fields set subjectidx=to_tsvector('default',value) where field=20;
+-- create index hf_subjectidx on header_fields using gist(subjectidx) where field=20;
+-- vacuum full analyze header_fields;
+--
+-- create function tsearch2_subject() returns trigger as $$
+-- begin
+--     if NEW.field = 20 then
+--         perform tsearch2(NEW.subjectidx, NEW.value);
+--     end if;
+--     return NEW;
+-- end;
+-- $$ language plpgsql;
+--
+-- create trigger hf_ftupdate before insert on header_fields
+-- for each row execute procedure tsearch2_subject();
